#version 330

uniform mat4 projectionMatrix;
uniform mat4 modelMatrix;
uniform mat4 viewMatrix;

in vec3 position;
in vec3 normal;

out vec3 worldNormal;
out vec3 surfacePosition;
out vec3 surfaceNormal;

void main(void) {		
	surfacePosition = vec3(modelMatrix * vec4(position, 1.0));
	surfaceNormal = normalize(transpose(mat3(inverse(modelMatrix))) * normal);

	worldNormal = (modelMatrix * vec4(normal, 0)).xyz;
	
	gl_Position = projectionMatrix * viewMatrix * modelMatrix *vec4(position, 1);
}
