#version 330

uniform vec3 Ld; //darf nicht rausoptimiert werden (?!)

in vec3 passover;

out vec4 fragColor;

void main()
{
	fragColor = vec4(1.0);
	fragColor += vec4(Ld, 0.0f);

	//VSM
	float depth=gl_FragCoord.z; // /gl_FragCoord.w; // division => doesnt seem blurred TODO
	depth = depth * 0.5 + 0.5; //map [-1,1] to [0,1]

	float moment1 = depth;
	float moment2 = depth * depth;

	// Adjusting moments (this is sort of bias per pixel) using derivative
	float dx = dFdx(depth);
	float dy = dFdy(depth);
	moment2 += 0.25*(dx*dx+dy*dy) ;

	//store depth, depth^2 for variance shadow mapping
	fragColor = vec4( moment1,moment2, fragColor.x, 1. );
}