#version 330

uniform mat4 projectionMatrix;
uniform mat4 modelMatrix;
uniform mat4 viewMatrix;

in vec3 position;
in vec3 normal;
in vec2 uv;

out vec3 worldNormal;
out vec2 fragmentUV;
out vec3 surfacePosition;
out vec3 surfaceNormal;

void main()
{
	fragmentUV = uv;
	worldNormal = (modelMatrix * vec4(normal, 0)).xyz;
	surfacePosition = vec3(modelMatrix * vec4(position, 1.0));
	surfaceNormal = normalize(transpose(mat3(inverse(modelMatrix))) * normal);
	
	gl_Position = projectionMatrix * viewMatrix * modelMatrix * vec4(position, 1);
}