#version 330

uniform mat4 projectionMatrix;
uniform mat4 modelMatrix;
uniform mat4 viewMatrix;
uniform mat4 shadow_tex_mat; //MT * MS * P_light * V_light

in vec3 position;
in vec3 normal;
in vec2 uv;

out vec3 worldNormal;
out vec2 fragmentUV;
out vec3 surfacePosition;
out vec3 surfaceNormal;
out vec4 shadow_tex_coord; 

void main()
{
	fragmentUV = uv;
	worldNormal = (modelMatrix * vec4(normal, 0)).xyz;
	surfacePosition = vec3(modelMatrix * vec4(position, 1.0));
	surfaceNormal = normalize(transpose(mat3(inverse(modelMatrix))) * normal);
	
	gl_Position = projectionMatrix * viewMatrix * modelMatrix * vec4(position, 1);
	// shadow texture coords in projected light space
	shadow_tex_coord = shadow_tex_mat * modelMatrix * vec4(position, 1);
}

/*uniform mat4 projectionMatrix;
uniform mat4 modelMatrix;
uniform mat4 viewMatrix;
//uniform mat4 shadow_tex_mat; //MT * MS * P_light * V_light

in vec3 position;
in vec3 normal;
in vec2 uv;

out vec3 worldNormal;
out vec2 fragmentUV;
out vec3 surfacePosition;
out vec3 surfaceNormal;
//out vec4 shadow_tex_coord; 


void main()
{
	fragmentUV = uv;
	worldNormal = (modelMatrix * vec4(normal, 0)).xyz;
	surfacePosition = vec3(modelMatrix * vec4(position, 1.0));
	surfaceNormal = normalize(transpose(mat3(inverse(modelMatrix))) * normal);
	
	gl_Position = projectionMatrix * viewMatrix * modelMatrix * vec4(position, 1);

	// shadow texture coords in projected light space
	//shadow_tex_coord = shadow_tex_mat * modelMatrix * vec4(position, 1);
}*/